# Squash All The CI Bugs!!!

## If This Helps You, Please Star This Project :)

One click can help us keep providing and improving Guided Explorations.  If you find this information helpful, please click the star on this project's details page!

If you know of improvements, please open an issue or merge request to share them!

## Overview Information

GitLab's features are constantly and rapidly evolving and we cannot keep every example up to date.  The date and version information are published here so that you can assess if new features mean that the example could be enhanced or does not account for an new capability of GitLab.

- **Product Manager For This Guided Exploration**: Darwin Sanoy (@DarwinJS)

- **Publish Date**: 2022-09-14

- **GitLab Version Released On**: 15.3

- **References and Featured In**:
  - https://www.linkedin.com/feed/update/urn:li:activity:6976161480870109184/

## Objectives 

![Squash All The CI Bugs](./squashallthecibugs.jpg)

- Demonstrate all known GitLab CI tracing enablement.
- Demonstate Git's built in tracing.
- Demonstrate simple tracing to add to job scripts.
- Demonstrate simple tracing for existing commands and utilities used in the job code.

## Demonstrates These Design Requirements, Desirements and AntiPatterns

- **GitLab CI Development Pattern [![FC](https://gitlab.com/guided-explorations/guided-exploration-concept/-/raw/master/images/FC.png)](https://about.gitlab.com/features/):** This project shows two built-in GitLab debug tracing variables 
  - `CI_DEBUG_TRACE` - built-in standard GitLab CI tracing documented in [Debug logging](https://docs.gitlab.com/ee/ci/variables/#debug-logging)
  - `AUTO_DEVOPS_DEPLOY_DEBUG` - built-in for tracing helm commands in AutoDevOps.
  - `TRACE` - built-in for tracing helm commands in AutoDevOps.
  - `JOB_TRACE` - custom example for enabling tracing of one's CI job scripts. Example enables `set -v` and has some custom messages to emit special data.  Allows focusing on just your own code without enabling the massive verbosity of `CI_DEBUG_TRACE`
  - `SOMEUTILITY_TRACE` - custom example of having specific code in this solution emit extra data. In this case it has to run the utility twice - so potentially an expensive operation to get tracing data as well as generating a lot of extra output - so controlled by a switch.
  - `GIT_SSH_COMMAND` - Set to exactly 'ssh -vvv' to trace SSH based cloning. By default the runner clones are https - this variable is most useful if you have custom ssh clones in your code.
  - `GIT_TRACE_PERFORMANCE` - enables tracing of performance data, showing how long each particular git invocation takes. From https://git-scm.com/book/en/v2/Git-Internals-Environment-Variables#_debugging
  - `GIT_TRACE_PACKET` - enables packet-level tracing for network operations.
  - `GIT_CURL_VERBOSE` - Git uses the curl library to do network operations over HTTP, so GIT_CURL_VERBOSE tells Git to emit all the messages generated by that library. From https://git-scm.com/book/en/v2/Git-Internals-Environment-Variables#_debugging
  - `GIT_TRACE_SETUP` - enables tracing of what git is discovering about the repository and environment it’s interacting with. From https://git-scm.com/book/en/v2/Git-Internals-Environment-Variables#_debugging

## Seeing It In Action

1. Hit run pipeline.
2. Set these variables:
  - JOB_TRACE 'true'
  - SOMEUTILITY_TRACE 'true'
  - GIT_TRACE_PERFORMANCE '1'
  - GIT_TRACE_SETUP '1'
  - GIT_TRACE_PACKET '1'
  - GIT_TRACE_VERBOSE '1'
3. Observe the Logs.

## Guided Explorations Concept

This Guided Exploration is built according to a specific vision and requirements that maximize its value to both GitLab and GitLab's customers.  You can read more here: [The Guided Explorations Concept](https://gitlab.com/guided-explorations/guided-exploration-concept/blob/master/README.md)

## Working Design Pattern

As originally built, this design pattern works and can be tested.
